Module.define('format',['jquery','replacetext'],function($) {
		
	function stripHTML(str) {
		return $('<div/>').html(str).text();
	}
		
	function htmlFormat(str) {		
		var ret = $('<div/>').html(str.replace(/\r?\n/g,'<br>'));
		ret.find(":not(b, strong, i, em, u, br, pre, blockquote, ul, ol, li, a)").remove();
		ret.find('*')
		   .replaceText(/\b((?:https?\:\/\/\S+)|(?:www\.\S+))\b/gi,'<a href="$1">$1</a>')
		   .each(function() {
				for (var i=this.attributes.length-1;i>=0;i--) {
					var attr = this.attributes[i];
					if (attr.name=='href' && this.nodeName==='A' && !(/javascript/gi.test(attr.value))) {
						continue;
					}
					this.removeAttribute(attr.name);
				}
			});
		return ret.html();
	}

	function truncateNicely(str, max) {
		if (str.length <= max) return str;
		var words = str.split(/\W/);
		var ret = "";
		for (var i=0;i<words.length;i++) {
			if (ret.length + words[i].length + 4 <= max) {
				ret += ' '+words[i];
			} else {
				return (ret.length == 0) ?
					(words[0].substring(0,max-3)+'...') : ret + '...';				
			}
		}
	}
	
	return {
		stripHTML: stripHTML,
		htmlFormat: htmlFormat,
		truncateNicely: truncateNicely,
		commaFormat: function( str) { 
			return parseInt(str).toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
		}
	};
});
	