Module.define('vcom/android',['jquery'],function($){
	var version = parseFloat(/Android (\d\.\d)/.exec(navigator.appVersion)[1]);
				
	$.ajaxPrefilter(function( options, _, jqXHR ) {
		if (/(auth|facebook|start)\.json$/.test(options.url)) {
			 jqXHR.setRequestHeader("X-License", window.policy.getData()+"|"+window.policy.getSignature() );
		}
	});
	
	// load backbutton support
	Module.after('vcom/history');
	
	$(function(){
		if (version >= 4.4) $('html').addClass('android chromeView');
		else $('html').addClass('android webView');
				
		if      (version == 4.1) $('html').addClass('api16');
		else if (version == 4.2) $('html').addClass('api17');
		else if (version == 4.3) $('html').addClass('api18');
		else if (version == 4.4) $('html').addClass('api19');
		
		// note this relies on the Android activiy manifest to specify 
		// android:windowSoftInputMode="adjustResize" in order to work
		$(window).on('resize',function(){
			$('html').toggleClass('keyboardUp',keyboardPlugin.isKeyboardVisible());
		});
		   
		
		if (version <= 4.1) {
			Module.after('vcom/dictionary',function(dict) {
				dict.allowSwipe=false;
			});		
			// fix challenge redraw bug
			$('body').on('challenge.go',function(){				
				$('.questionPane').doTimeout(400,function(){ 
					this.css('transition-duration', 0);	
		    	});
			});			
		} else if (version < 4.4) {
			// force redraw on dictionary swipe/load
			$('body').on('dictionary.loaded','#dictionaryContent .slide.current',function(){
				$(this).doTimeout(25,function(){ 
					$('#dictionaryContent').css('transform','');	
				});
			});
		}
		
		$('head').append('<link href="css/android.css" rel="stylesheet" type="text/css">');
				
		$('body').on('challenge.showFrame',function(e) {
				var $target = $(e.target);
				if ($target.data('slide-type')=='spelling') {
					var input = $(e.target).find('input.wordspelling');

					if ($target.hasClass('active')) {
						window.spellingInput.setText(input.val());
						$target.find('.playword').on('touchstart',function(){ 
							doFocus(); 
							VCOM.playAudio($target); 			   			 
				   			 return false;
				   		});
						
						input.on('touchstart',function(){
							doFocus();
							return false;
						}).on('focus',function(){
							this.blur();
							doFocus();
							return false;
						})
					} else {
						input.prop('disabled',true);
					}				
					function doFocus() {
						if (!$target.hasClass('active')) {
							doBlur();
							$('body').off('touchstart',doBlur);
							return;
						}					
						var off = input.offset();
						input.css('color','transparent');
						window.spellingInput.show(off.left+35,off.top,input.outerWidth()-35,input.outerHeight());
						window.spellingInput.focus();
						$('body').one('touchstart',doBlur);
					}
					function doBlur() {
						input.val( window.spellingInput.getText() ).css('color','');
						window.spellingInput.hide();
					}
				}
		});	
	});	
			
	// replace canvases with images in wordfamilies
	if (version < 4.4) {
		Module.after('vcom/wordfamily',function(wf){
			var superConstruct = wf.construct;
			wf.construct = function() {
				var ret = superConstruct.apply(this,arguments);
				$(this).on('resized wordfamily-select',replaceCanvas);
				replaceCanvas.call(this);
				return ret;
			};				
			function replaceCanvas() {
				$(this).find('canvas').each(function(){
					var data = this.toDataURL('image/png');
					var img = $('<img/>').attr('src',data);
					$(this).replaceWith(img);
				}).remove();
			}
			
		});
	}	
	
	
});