Module.define('vcom/apprater',['jquery'],function($){
	var ACTIONS_TO_RATE = 120;
	var RATE_URL =  (window.ios) ?
			'itms-apps://itunes.apple.com/app/id815218412?at=10l6dK' :		 
			'market://details?id=com.vocabulary.app';
			         	
	var rated = false,
	    remaining = ACTIONS_TO_RATE;
	    
	document.addEventListener('deviceready',function(){
		rated = (localStorage['settings.rated']=='true');
		
		
		if (window.ios && window.device && parseFloat(window.device.verion) < 7) {
			RATE_URL = 'itms-apps://itunes.apple.com/WebObjects/MZStore.woa/wa/viewContentsUserReviews?type=Purple+Software&id=815218412?at=10l6dK';	
		}
		
		if (!rated) {
			remaining = parseInt(localStorage['settings.actionsUntilRating']);
			if (isNaN(remaining)) remaining = ACTIONS_TO_RATE;
			$(document).on('challenge.nextQuestion dictionary.loaded',actionPerformed);
		}		
	}, false );
	
	VCOM.rateApp = function() {
		rated = true;
		localStorage['settings.rated'] = true;		
		window.open(RATE_URL,'_system');
	}
	
	VCOM.submitFeedback = function(){
		var $details = $('<div></div>').addClass('loading');
		var modal=VCOM.showModal($details);
		modal.find('.done').text('CANCEL');
		$details.smartLoad('feedback.html',function(){
			$details.removeClass('loading');	
			$form = $details.find('form')
			$form.validate({
				 submitHandler: function(){
					 modal.hide();
					 $.post(VCOM.server+'/feedback.json', $form.serialize());
					 navigator.notification.confirm("Your feedback has been submitted!",function(){},"Thanks!",["Ok"]);
				 }
			});
		});
	};
	
	function showRatingDialog() {
		navigator.notification.confirm("",function(choice){
			if (choice==1) {
				  navigator.notification.confirm("Would you mind taking a moment to tell us how we can improve?",
						function(choice) {
					  		rated = true;
					  		updateSettings();
					  		if (choice==2) {
					  			VCOM.submitFeedback();
					  		}
				  		},"Help us improve",["No Thanks","Send Feedback"]);
			} else if (choice == 2) {
				  navigator.notification.confirm("Would you like to take a moment to rate us in the App Store?",
						  function(choice) {
							  if (choice==1) {
								  remaining = ACTIONS_TO_RATE; 								 
					  		   } else if (choice == 2) {
					  			   rated = true;
					  		   } else if (choice == 3) {
					  			   VCOM.rateApp();
					  		   } else {
					  			  // default is the same as "maybe later"
 					  			  remaining = ACTIONS_TO_RATE;  
					  		   }
					  		 updateSettings();
				  },"Rate Vocabulary.com",["Maybe later","No thanks","Sure!"]);
			  } else {
				  // default is the same as "maybe later"
				  remaining = ACTIONS_TO_RATE;
				  updateSettings();
			  }
		},"Do you like Vocabulary.com?",["No","Yes"]);
	}	
	
	function actionPerformed() {
		remaining--;
		updateSettings();
	}
	
	function updateSettings() {
		$.doTimeout('store-rate-settings',5000,function() {			
			localStorage['settings.actionsUntilRating'] = remaining;
			localStorage['settings.rated'] = rated;						
			if (remaining <= 0 && !rated) {
				showRatingDialog();
			}
		});
	}
	
});