Module.define('vcom/dictionary', ['jquery','vcom/base','vcom/autocomplete'], function($,VCOM,autocomplete){
	
	var _this= this;
	
	this.allowSwipe = true; 
	
	var $body,
	    autoComplete,
	    $dictionary, 
	    $search,
	    $autoComplete,
	    dictionaryContent,
	    $slider,
	    wordHistory = [], historyPtr = -1,
	    currentSlide;
	
	var nextPage,prevPage;
	
	VCOM.dictionary = {
		prev : function() { return go(-1); },
		next : function() { return go(1); }
	};
	VCOM.on('login',configure);
	VCOM.on('change:mode',function(vcom,mode){ 
		if (mode == 'dict') {
			$dictionary.find('.resizable').trigger('resized');
		} else {
			if ($body) hideAC();
		}
	});		
	
	function configure() {
		$body = $('body');
		autoComplete = new autocomplete.Autocomplete('#autocomplete', '#search');				
		$dictionary   = $('#dictionary');
		$search = $('#search')
		$autoComplete = $('#autocomplete');
		dictionaryContent = $('#dictionaryContent')
		                         .on('touchstart', touchStart )
		                         .empty();
		$slider = $('<div class="slider"></div>').appendTo(dictionaryContent);
		
		
		$('#autocomplete').on('touchstart',function(){});
		
		
		wordHistory = [];
		historyPtr = -1;
		
		var current = localStorage.getItem('dictionary.current');
		if (current && current.length) {
			current = $(current);
			currentSlide = $('<div class="slide current"></div>').append(current)
			            .appendTo($slider).data(current.data());
			$body.addClass('withresults');
			VCOM.parse(currentSlide);
			historyPtr = parseInt(localStorage.getItem('dictionary.historyPtr'))||-1;
			try{ wordHistory = JSON.parse(localStorage.getItem('dictionary.history')); } catch(e) {};
			if (wordHistory == null || (typeof wordHistory.push != 'function')) {
				wordHistory = [];
				historyPtr = -1;
			}			
		}
		
		$search.on('change input propertychange', function() {
			var empty = (this.value.trim().length == 0);
			$('.mainNav .dictTab').toggleClass('empty',empty);
			$body.toggleClass('withsearch',!empty);
		}).on('focus',function(){
			VCOM.mode('dict');
			if (this.value.trim().length) {
				showAC();
			}
		});

		$dictionary.children('.list-header').on('click',function() {
			 acOpen(!acOpen());
		});
		
		dictionaryContent.on('mouseover','.definitionNavigator .posList a',function(){
			$this = $(this);
			$this.addClass('selected')
				.siblings().removeClass('selected')
				.closest('.definitionNavigator')
				.find('.def.'+$this.attr('href').substring(1))
				.addClass('selected')
				.siblings().removeClass('selected');				
		});
		dictionaryContent.on('click','a.expander',function() {
			$(this).closest('.instances').toggleClass('expanded');
		});
		
		$autoComplete.addClass('autocomplete')
		.on('autocomplete.selectionchanged',function(evt) {	
			var word = autoComplete.getSelectedWord();
			 if (word != null) {
				showSoon( { word : word.word, lang : word.lang } );						
			} else {
				acOpen(false);
			}			
		})
		.on('autocomplete.update',function( evt ) { 
			if (autoComplete.getSelectedWord() == null && autoComplete.hasWords()) {				
				if (VCOM.mode()=='dict') {
					var word = autoComplete.getWordAt(0);
					showSoon( {word:word.word,lang:word.lang,delay:0}, function() {
						VCOM.history.push( VCOM.dictionary.prev );
					} );
					if (autoComplete.getText() == word.word) {
						hideAC();
					} else {
						showAC();						
					}					
				}
			} else if (!autoComplete.hasWords()) {
				clearResults();
			}
		})
		.on('autocomplete.click',function(evt) { 		
			showSoon( { word : evt.word,   lang : evt.lang, delay: 0 },function() {
				VCOM.history.push( VCOM.dictionary.prev );
			} );
			hideAC();
			search.blur();
		})
		.on('autocomplete.enter',function(evt) { 		
			cancel();
			if (evt.word) {
				$search.val(evt.word);
				showSoon( { word : evt.word,   lang : evt.lang, delay: 0 },function() {
					VCOM.history.push( VCOM.dictionary.prev );
				} );
				evt.preventDefault();
			}			
			hideAC();
			$search.blur();
		});
	 
		
		
	}
	
	VCOM.goWord = go; 
	VCOM.debugHistory = function() {
		console.log('ptr:',historyPtr);
	};
	
	VCOM.displayWord = function(word,lang,callback) { 
		lang = lang || 'en';
		VCOM.mode('dict');
		if (!word || word.length==0) {
			clearResults();
		} else {			
			showSoon({word:word,lang:lang,delay:0},callback);							
		}
		return this;
	};
	
	VCOM.randomWord = function() {
		$.post(VCOM.server+'/dictionary/randomword.json',function(result){
			if (result && result.word) {
				VCOM.displayWord(result.word);
			}
		},'json').fail(VCOM.errorHandler(VCOM.randomWord));
	};
	
	function acOpen() {
		if (!arguments.length) return $body.hasClass('ac-open');
		var open = !!arguments[0];
		var isOpen = $body.hasClass('ac-open');
		if (!open && isOpen) {
			var ach = autoCompleteHeight();
			if (autoCompleteHeight() > 0) {
				$dictionary.addClass('animating');
				$body.removeClass('ac-open');	
				dictionaryContent.one('transitionEnd webkitTransitionEnd',function(){
					$dictionary.removeClass('animating');
				});
			} else {
				$body.removeClass('ac-open');	
			}				
		} else if (open && !isOpen) {
			$body.addClass('ac-open');			
			if (autoCompleteHeight()>0) {
				$dictionary.addClass('animating');
				dictionaryContent.one('transitionEnd webkitTransitionEnd',function(){
					$dictionary.removeClass('animating');
				});
			}
		}		
	}
	VCOM.acOpen = acOpen;
	
	function hideAC() { acOpen(false); }
	function showAC() { acOpen(true); }
	
	function autoCompleteHeight() {
		return parseInt(getTransform(dictionaryContent)[1]);
	}
	
	function getTransform(el) {
	    var results = $(el).css('-webkit-transform').match(/matrix(?:(3d)\(\d+(?:, \d+)*(?:, (\d+))(?:, (\d+))(?:, (\d+)), \d+\)|\(\d+(?:, \d+)*(?:, (\d+))(?:, (\d+))\))/);
	    if(!results) return [0, 0, 0];
	    if(results[1] == '3d') return results.slice(2,5);
	    results.push(0);
	    return results.slice(5, 8);
	}
	
	function storeState() {
		if (currentSlide) {
			localStorage.setItem('dictionary.current',currentSlide.html());
			localStorage.setItem('dictionary.word',currentSlide.data('word'));
			localStorage.setItem('dictionary.lang',currentSlide.data('lang'));			
		} else {
			localStorage.removeItem('dictionary.current');
			localStorage.removeItem('dictionary.word');
			localStorage.removeItem('dictionary.lang');
		}	
		localStorage.setItem('dictionary.history',JSON.stringify(wordHistory));
		localStorage.setItem('dictionary.historyPtr',historyPtr);
	}
	
	
		
	function touchStart(evt) {
		if ($slider.data('animating')) return;
		
		dictionaryContent.one('touchend',end).on('touchmove',move);
		var lastY = evt.originalEvent.touches[0].pageY,
			lastX = evt.originalEvent.touches[0].pageX,
		    startY = lastY, 
		    startX = lastX,		    
		    dx =0, dy = 0,
		    isSwipe = null;
		var startScrollPos = $dictionary.find('.slide.current').scrollTop();
		
		function move(e) {
			if (e.originalEvent.touches.length != 1) {
				if (isSwipe) dictionaryContent.trigger({type:'swipeend',direction:0});
				cancel();
				return;
			}
			
			if (!$dictionary.hasClass('pulling')) {
				$dictionary.addClass('pulling');
			}
			
			
			var acHeight = autoCompleteHeight();
			var cy = acHeight;
			var y = e.originalEvent.touches[0].pageY;
			var x = e.originalEvent.touches[0].pageX;
			dy  = y-lastY;
			dx  = x-lastX; 
			lastY = y;
			lastX = x;
			
			
			
			if (isSwipe == null) {
				isSwipe = (Math.abs(dx)>Math.abs(dy));
				if (isSwipe) {
					dictionaryContent.trigger('swipestart');
				} else if (dy < 0 && startScrollPos == 0 && acHeight==0) {
					cancel();
					return;
				}
			}
			if (isSwipe) {
				if (prevPage==null && x-startX > 10) {
					loadPrevPage();										
				} else if (nextPage==null && x-startX < -10) {
					loadNextPage();						
				}
				translate(x-startX);
				e.preventDefault();
				e.stopPropagation();
				return false;
			} else {
				if (((dy < 0 && cy > 0) || (dy >= 0 && cy < 256 && startScrollPos == 0))) {
					cy = Math.min(256,Math.max(0,cy+dy));
					dictionaryContent.css('transform','translate3d(0,'+cy+'px,0)');
					e.preventDefault();
					e.stopPropagation();					
					return false;
				}			
			}			
		}
		function end() {							
			if (isSwipe) {
				var direction = (lastX-startX > 50) ? -1 : 
					(lastX-startX < -50) ? 1 : 0;
				dictionaryContent.trigger( $.Event('swipeend',{direction:direction} ) );
				go( direction );				
				cancel();
			} else {				
				if (dy >= 0 && lastY-startY > 20 && startScrollPos == 0) {
					showAC();
				} else {
					hideAC();
				}
				cancel();
			}
			nextPage = prevPage = null;
		}
		
		function cancel() {			
			$dictionary.doTimeout(10,'removeClass','pulling');
			dictionaryContent
			  .off('touchend', end )
			  .off('touchmove', move );
			if (!isSwipe) {
				dictionaryContent.css('transform','');	
			} else {
				$slider.children().css({transition:'',transform:''});				
			}
			
		}	
	}
	
	function translate(dx) {
		if (_this.allowSwipe) {
			var w = $slider.width();
			if (currentSlide) currentSlide.css({transition:'none',transform:'translate3d('+dx+'px,0,0)'});
			if (prevPage) prevPage.css({transition:'none',transform:'translate3d('+(dx-(w+20))+'px,0,0)'});
			if (nextPage) nextPage.css({transition:'none',transform:'translate3d('+(dx+(w+20))+'px,0,0)'});
		}
	}
		
	function clearResults() {
		cancel();				
		$slider.empty().css({'transition':''});
		$body.removeClass('withresults');
		currentSlide = null;
		$.doTimeout('storestate',1000,storeState);
	}
	
	function showSoon(options,callback) {
		cancel();
		
		if (currentSlide && samePage(currentSlide,options)) {
			//if (window.debug) console.log('already showing ',options.word);
			if (callback) callback();
			return; // already showing that word			
		}
		
		$dictionary.trigger('dictionary.loading');		 
		
		var delay = (options.delay==null) ? 300 : options.delay;
		if (delay) {
			$dictionary.doTimeout('show',delay,function(){
				loadPage( options, options.direction||'next',function() {
					//if (window.debug) console.log('transitioning to ',options.word,$(this).data());					
					transitionTo($(this),function(){
						pushHistory({word:options.word,lang:options.lang});
					});
					if (callback) callback();
				} );
			});
		} else {
			transitionTo(loadPage( options, options.direction||'next',function() {
				//if (window.debug) console.log('transitioning to ',options.word);
				pushHistory({word:options.word,lang:options.lang});
				if (callback) callback();
			} ));
		}
	}
	
	function cancel() {
		$dictionary.doTimeout('show');
	}
	
	
	function loadNextPage() {
		if (!nextPage) {
			if (historyPtr < wordHistory.length-1) {
				nextPage = loadPage(wordHistory[historyPtr+1],'next');
			} else {				
				var word = currentSlide.data('next');				
				if (word) {
					nextPage = loadPage({word:word,lang:currentSlide.data('lang')},'next');
				}
			}
		}		
		return nextPage;
	}
	function loadPrevPage() {
		if (!prevPage) {
			if (historyPtr > 0) {
				prevPage = loadPage(wordHistory[historyPtr-1],'prev');
			} else {
				var word = currentSlide.data('prev');
				if (word) {
					prevPage = loadPage({word:word,lang:currentSlide.data('lang')},'prev');
				}
			}
		}
		return prevPage
	}
	
	function pushHistory( data, atStart ) {		
		if (atStart) {			
			wordHistory.unshift(data);		
			historyPtr=0
			while (wordHistory.length>500) wordHistory.pop();
		} else {
			if (historyPtr < wordHistory.length-1) {
				var forward = wordHistory.splice(historyPtr,wordHistory.length-historyPtr).reverse();
				forward.push(data);
				wordHistory.push.apply(wordHistory,forward);
				historyPtr = wordHistory.length-1;
			} else {
				wordHistory[++historyPtr]=data;				
			}			
			while (wordHistory.length>500) wordHistory.shift();
		}
	}
	
	function go( direction ) {
		direction = Math.max(-1,Math.min(1,direction||0));
		var page;
		var ret = false;
		if (direction>0) {
			$dictionary.trigger('dictionary.loading');
			page=loadNextPage();				
		} else if (direction<0) {
			$dictionary.trigger('dictionary.loading');
			page=loadPrevPage();				
		}
		if (page) {
			if (historyPtr == 0 && direction < 0) {
				pushHistory({word:page.data('word'),lang:page.data('lang')},true);				
			} else if (historyPtr == wordHistory.length-1 && direction > 0) {
				pushHistory({word:page.data('word'),lang:page.data('lang')});
			} else {
				historyPtr+=direction;
				ret = true;
			}
		}
		transitionTo(page || $slider.children('.current'));
		
		VCOM.history.push(function(){ go(-direction); });
		
		return ret;
	}
		
	function loadPage(wordObject,pageType,callback) {
		if (!wordObject) return;
		
		if (!$slider.data('animating')) {
			var existing = $slider.children('.slide.'+pageType);
			if (samePage(existing,wordObject)) {
				if (callback) setTimeout(function(){callback.call(existing);},1);
				return existing;
			}
		}
		var element = $('<div class="slide loading"></div>').addClass(pageType)
		              .data('word',wordObject.word)
		              .data('lang',wordObject.lang);
		
		(function doIt() {		
	    $.get(VCOM.server+'/dictionary/search',{word:wordObject.word},function( content ){
			try {
		        content = $(content);						
				element.append(content).doTimeout(10,'removeClass','loading');
				element.data(content.data()); // copy data to parent
				VCOM.mode('dict');
				VCOM.parse(element);
			    $body.addClass('withresults');
			    if ((content).hasClass('noresults')) {
					showAC();	// TODO: not sure what to do here.. must test				
				} 
			    if (callback) callback.call(element);
			} catch (e) {
				VCOM.error({cause:e,message:'error loading dictionary page'});
			}
	    },'html').fail(VCOM.errorHandler(doIt)) })();
			
		element.appendTo($slider);

		return element;
	}
	
	function samePage(slide,wordObject) {
		return (slide.length &&
				slide.data('word') == wordObject.word && 
				slide.data('lang') == wordObject.lang);
	}
	
	
	function transitionTo(slide,callback) {		
		if (slide && slide != currentSlide) {
			if (slide && slide.hasClass('next')) {
				if (currentSlide) currentSlide.addClass('prev');
				slide.removeClass('next').addClass('current');
			} else if (slide && slide.hasClass('prev')) {
				if (currentSlide) currentSlide.addClass('next');
				slide.removeClass('prev').addClass('current');
			}
			var toRemove = slide.siblings();
			currentSlide = slide;
			$slider.doTimeout('transition',350,function(){
				$slider.data('animating',false);
				toRemove.remove();
				slide.trigger('dictionary.loaded');		    	
		    	if (callback) callback.call(slide);		    	
		    	$.doTimeout('storestate',1000,storeState);
		    	
			});
			nextPage = prevPage = null;
		}
	}	
	
});