Module.define('vcom/ios',['jquery'],function($){
	
	$(function(){
		$('html').addClass('ios');		
		
		// fix for ios7 bug where scroll events pass through fixed or absolutely positioned elements that 
		// hover over scrollable panes.  We detect touchstart events on everything, and if they originate
		// on an element that is contained by a scrollable div (that actually is able to scroll), we allow
		// the event to pass through.  Otherwise, we prevent default.
		$(document.body).on('touchstart',function(e){
			for (var elem = e.target;elem!=null;elem=elem.parentElement) {
				if (verticallyScrollable(elem)) return;
			}
			return e.preventDefault();
		});
		
		document.addEventListener('deviceready',function(){
			correctViewport();
			$(window).on('orientationchange resize',correctViewport);	
		},false);				
	});
	
	function verticallyScrollable(elem) {
		if (elem.scrollHeight > elem.clientHeight || elem.scrollWidth > elem.clientWidth) {
			if ($(elem).css('overflow-scrolling')=='touch') {
				return true;
			}
		}
	}	
	
	function correctViewport() {
		$('body,html').css(
				{'min-height':window.innerHeight + 'px',
				 'height':window.innerHeight + 'px'});
		$('meta[name=viewport]').attr('content','width=device-width, height='+window.innerHeight+',initial-scale=1.0, maximum-scale=1.0');
	}
});