Module.define('vcom/login', ['jquery','vcom/base','jquery.validate','slider'],function($,VCOM) {
  
	var monthNames=["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];
	
	var dateSupport = (function(){
		var i= document.createElement("input");
		i.setAttribute("type", "date");
		return (i.type === 'date');
	})();
	
	
	VCOM.login = function() {
		$('body').attr('class','loggedout');
		home();
	};
	
	function homeLeft() { home(-1); }
		
	function home(dir) {
		VCOM.history.remove(homeLeft);
		VCOM.history.remove(home);
		
		transitionTo('intro0.html',{direction:dir==-1?-1:1,onload:function(){
			var dots = $('body>.wrapper.dialog .markers span');		
			$(this).find('a.signin').on('click',debounce(signIn));
			$(this).find('a.signup').on('click',debounce(VCOM.signup));	
			
			var slider = $(this).find('.carousel').on('slider-go',function(evt,idx) {
				
				$(dots[idx]).addClass('selected').siblings().removeClass('selected');	
			}).on('slider-next',function(){
				VCOM.history.push(slider.prev);
			}).on('slider-prev',function(){
				VCOM.history.push(slider.next);
			}).slider();
		}});
	}
	
	
	function signIn() {
		transitionTo('login.html',{onload:configureLogin,direction:-1});
	}

	VCOM.signup = function() { 
		var $wrapper = $('<div></div>').smartLoad('signup.html',function(){
			$wrapper = $wrapper.children().unwrap();
			configureSignup($wrapper);
			transitionTo($wrapper);
		});
	}	
	
	VCOM.logout = function() { 		
		introStep =-1;
		$('body').trigger('vcom.logout');
		localStorage.clear();
		$.post(VCOM.server+'/logout.json',{_d:Date.now()}).always(function() {
			VCOM.set({'auth':null,'pdata':null,'mode':null});
			VCOM.trigger('logout');
			VCOM.login();
		});
		return this;
	}	
		
	function configureLogin(wrapper) {
		VCOM.history.push(home);
		wrapper.find('.back').on('click',debounce(home));		
		wrapper.find('.signup').one('click',debounce(VCOM.signup));		
		wrapper.find('#loginform').validate({submitHandler:doLogin});
		wrapper.find('.fblogin').on('click',debounce(fbLogin,5000));		
	}
	
	function doLogin() {
		$('#loginform .actions button').text('Signing In...');
		$.post(VCOM.server+'/login.json', $('#loginform').serialize(),function(data){
			 if (data.auth && data.auth.loggedin) {
				 _doLoginResponse(data);
			 } else {
				 fail('We did not recognize that username and password combination, please try again.');
				 $('#loginform .actions button').text('Sign In');
			 }
		 }).fail(function(xhr) {
			 if (xhr && xhr.status == 406) VCOM.forceUpgrade();
			 fail('A server error occurred, please try again later.');
		 });
	}
	
	VCOM.auth = function() {
		var post = {};
		var secret = localStorage.getItem('challenge.secret');
		if (secret) post.secret = secret;		
		$.post(VCOM.server+'/auth.json',post, _doLoginResponse )
		    .fail( VCOM.errorHandler( VCOM.auth ) );
	}
	
	VCOM.loginViaKey = function( post ) {
		$('body').trigger('vcom.logout');
		localStorage.clear();
		$.post(VCOM.server+'/loginkey.json',post, _doLoginResponse )
		    .fail( VCOM.logout );
	};
	
	function _doLoginResponse(data) {
		try {
		if (data && data.auth && data.auth.loggedin) {
			VCOM.playerData(data.pdata);
			VCOM.set({auth:data.auth,pdata:data.pdata,valid:!!data.valid});
			transitionTo('maintabs.html',{direction:-1,onload: function(page){
				$('body').removeClass('loggedout');
				VCOM.trigger('login');
				return true;
			}});
		} else {
			VCOM.logout();
		}
		} catch (e) {
			console.error('caught exception in login',e)
			VCOM.logout();
		}
	}
	
	function fbLogin() {   
		$('.fblogin').text('Signing in...');
		FB.getLoginStatus(function(response) {
			 if(response && response.session) {
				 _fblogin(response);
			 } else {
				 FB.login(_fblogin, {scope:'email'},function(){
					 $('.fblogin').text('Sign in with Facebook');
					 console.log('error signing into facebook',arguments)
				 });
			 }					 
		 },function(){
			 $('.fblogin').text('Sign in with Facebook');
			 console.log('error getting login status',arguments);
		 });
	
		function _fblogin(response) {
			 $.post(VCOM.server+'/facebook.json',{token:response.authResponse.accessToken},function(data) {
				if (data && data.auth && data.auth.loggedin) {
					_doLoginResponse(data);
				} else {
					fail('there was an error logging you in with Facebook, please try again later.');
				}
			 }).fail(function(xhr) {
				 $('.fblogin').text('Sign in with Facebook');
				 if (xhr && xhr.status == 406) VCOM.forceUpgrade();
				 fail('A server error occurred, please try again later.');
			 });
		 }		 
	 }
	
	 function fail(message) {
		 $('body > .wrapper .messages').text(message).slideDown();
	 }	
	 
	 function debounce(fn,delay) {
		 var blocked = false;
		 return function() {
			 if (blocked) return;
			 blocked = true;
			 setTimeout(function(){ blocked=false; },delay||1000);
			 return fn.apply(this,arguments);
		 };		 
	 }
	 
	 function configureSignup(page) {	
		 VCOM.history.push(homeLeft);
		 if (!dateSupport) replaceDates();
		 page.find('.back').on('click',debounce(function(){ home(-1); }));
		 page.find('.fblogin').on('click',debounce(fbLogin,5000));	
		 page.find('.signin').one('click',debounce(function(){
			 transitionTo('login.html',{onload:configureLogin,direction:-1});
		 }));
		 var $form = page.find('form.signup');
		 $form.validate({
     		 submitHandler: debounce(doSignup, 3000),
			 rules: {
				 'form.birthday.month' : {
					 required: true,						
					 birthday: true
				 },				 
				 'form.birthday': {
					 required: true,
					 birthday: true
				 },
				 'form.emailaddress': {
					 required: true
			     },
			     'form.password2': {
					 equalTo: 'form.signup #password'
			     },
				 'form.username': {
					 required: true,
					 remote: {
						 url:VCOM.server+'/checkuser.json',
						 data: {
							 username: function(){ return $form[0]['form.username'].value; }
						 }				     		 
					 },
					 
				 }
			 },
			 messages: {
				 'form.birthday': {
					 max: 'Please enter a date in the past.'
				 },
				 'form.username': {
				 	remote: 'That username is already in use. Please try another.'
				 },
				 'form.password2': {
					 equalTo: 'The passwords you entered did not match.'
				 },
				 'form.agree': {
					 required: 'You must agree to the Terms of Service to continue.'
				 }
     		 }
		 });
		 page.find('.newword').on('click', function(){ getCaptcha(true); });
		 page.find('.playword').on('click', function(){
				$.ajax({
					url: VCOM.server+'/captcha/getaudio',
					cache: false,
					success: function(data) {
						VCOM._playAudio(data.result);
					}
				});
		});
		 
		function doSignup() {
			 $form[0]['form.timezoneOffset'].value =-(new Date().getTimezoneOffset());
			 
			 $form.find('button.submit').text('Creating Login...');
			 
			 $.post(VCOM.server+'/createlogin.json', $form.serialize(),function(result) {
				 if (result.status == 0) {
					 // TODO: profile page?
					 document.location.href = 'index.html';
				 } else if (result.exception && result.exception.messages) {
					 $form.find('button.submit').text('Create Your Login');
					 var errors = {};
					 for (var i =0;i<result.exception.messages.length;i++) {
						 var message = result.exception.messages[i];
						 if (!errors[message.propertyPath]) {
							errors[message.propertyPath] = message.message;
						 }
					 }
					 var validator = $form.validate();
					validator.showErrors(errors);
					validator.focusInvalid();
					
					if (errors.captcha) {
						getCaptcha(true);
					}
					
				 }	     				
			 }).fail(VCOM.errorHandler(function(){
				 $form.find('button.submit').text('Create Your Login');
			 }));		 		 
		} 
		 
		function getCaptcha(reset) {
			page.find('.field.captchaverification .value').css('background-image', 
				'url("'+VCOM.server+'/captcha/' + +(new Date()) + '.gif' + (reset ? '?reset=true' : '') + '")')
				.on('click',function(){
					$('.field.captcha input').focus();
				});
		}
		getCaptcha();
			
		page.find('#birthday').on('input',function(){
			var bday = this.value.split('-');
			var d = new Date(parseInt(bday[0])+13,parseInt(bday[1])-1,parseInt(bday[2]));
			if (d.getTime() > new Date().getTime()) {
				$form.addClass('under13').find('.field.form_emailaddress .label').text('Parent\'s Email:');
			} else {
				$form.removeClass('under13').find('.field.form_emailaddress .label').text('Email:')
			}		
		 }).attr('max',(new Date().format('yyyy-mm-dd')));		
	 	 
		 function replaceDates() {
			 page.find('input[type="date"]').each(function() {
				var $this = $(this).attr('type','hidden');
				var months = $('<select required name="form.birthday.month"><option value="">Month</option></select>');
				for (var i=0;i<12;i++) months.append($('<option/>').text(monthNames[i]).attr('value',i+1));
				
				var days = $('<select name="form.birthday.date"><option value="">Day</option></select>');
				for (var i=1;i<=31;i++) days.append($('<option/>').text(i).attr('value',i));
				
				var y = new Date().getFullYear();
				var years = $('<select name="form.birthday.year"><option value="">Year</option></select>');
				for (var i=0;i<100;i++) years.append($('<option/>').text(y-i).attr('value',y-i));
				
				$([months[0],days[0],years[0]]).insertBefore($this);
				
				$this.parent().find('select').on('change',function() {
					var valid = $(this).valid();
					$this.val( valid ? (years.val()+'-'+months.val()+'-'+days.val()) : '' )
					     .trigger('input');
					$form.validate().element(months);
				});
			 });
		 }
	 }
	 
	 // PAGE TRANSITIONS
	 var defaultOptions = {direction:1,onload:function(){},transitionEnd:function(){}};
		
	 function transitionTo(content,options) {
			options = $.extend({},defaultOptions,options);
			if (typeof content === 'string') {
				var $wrapper = $('<div></div>').smartLoad(content,function() {
					$wrapper = $wrapper.children().unwrap();
					transitionTo($wrapper,options);
					options.onload.call($wrapper[0],$wrapper);
				});
				return;
			}		
			var direction = (options.direction==-1) ? 100 : -100;
			var currentWrapper = $('body>.wrapper');		
			currentWrapper.one('transitionEnd webkitTransitionEnd',function(){
				currentWrapper.remove();
				content.css({'transition':'','transform':''});
				options.transitionEnd.call(content[0],content);
			}).css({'transition':'all .4s','transform':'translate3d('+direction+'%,0,0)'});
			content.css({'transform':'translate3d('+(-direction)+'%,0,0)','transition':'all .4s'});
			content.appendTo('body');
			content[0].clientHeight; // trigger layout
			content.css({'transform':'translate3d(0,0,0)'});
			return content;
	 }
	 
	
	 jQuery.validator.addMethod("birthday", function(value, element) {
		 if (element.type=='date') {
			 return (element.value.length && element.value <= element.getAttribute('max'));
		 } else {
			 var y = element.form['form.birthday.year'].value;
			 var m = element.form['form.birthday.month'].value;
			 var d = element.form['form.birthday.date'].value;
			 if (y.length && m.length && d.length) {
				 return (
					(new Date(parseInt(y),parseInt(m)-1,parseInt(d))).format('yyyy-mm-dd') <
					(new Date().format('yyyy-mm-dd')));				 
			 }
		 }
	 }, "Please specify a valid birth date.");
	
                        		 
});