Module.define('vcom/status',['jquery','vcom/base','date','vcom/progress'],function($,VCOM){
	var status = VCOM.status = {};
	var current = null;
		
	$.fn.hideStatus = function() {
		this.filter('.statusbar').each(function() {
			$this = $(this);
			$this.doTimeout('remove',500,function(){ 
				if (this.hasClass('hidden')) this.detach();
			});
			$this.addClass('hidden');
		});
		return this;
	};
	$.fn.showStatus = function() {
		this.filter('.statusbar').appendTo('body > .wrapper').each(function() {
			$this = $(this);
			this.clientHeight; // trigger layout
			$this.removeClass('hidden');
			$this.doTimeout('remove'); // cancel remove
			this.clientHeight; // trigger layout
		});
		return this;
	};
	
	VCOM.status.message = function(message,correct) {
		$.doTimeout('hidestatus',false); // force previous message to hide
		
		var $body = $('body');	
		var element = $('<div class="messages statusbar hidden"><header><div class="centeredcontent clearfloat"><div class="pane"></div></div></header></div>');		
		element.find('.pane').append(message).addClass((correct?'correct':'incorrect'));
		element.appendTo('body > .wrapper');		
		element[0].clientHeight; // trigger layout		
		$body.addClass('with-status-messages');
		element.removeClass('hidden')
		$.doTimeout('hidestatus',2000,function() {			
			element.addClass('hidden').doTimeout(500,'remove');
			$body.removeClass('with-status-messages');
		});		
		return this;
	};
		
	VCOM.status.create=function( content ) {
		var element = $('<div class="statusbar hidden"><header><div class="centeredcontent"><div class="pane"></div></div></header></div>');
		element.find('.pane').append(content);
		return element;
	};
	
	
	// setup "now playing" list selector
	(function(){
		var nowPlaying = VCOM.status.create('<div><i class="progress"></i><div role="button" class="nowplaying"><span class="label">Currently Playing:</span><span class="title" >All Words</span></div><button class="choose ss-navigateup"></button></div>')
		                .addClass('listprogress')
		                .append('<section></section>');		
		var $header  =nowPlaying.find('header');
		VCOM.on('change:activelist',function(vcom,list) {
			if (list == null) {
				nowPlaying.addClass('allwords').removeClass('mastered');
				$header.find('.title').text('All Words').end()
				       .find('i.progress').attr({'data-prg':null,'data-listid':null}).hide();				
			} else {				
				$header.find('.title').text(list.name).end()
			           .find('i.progress').attr({'data-prg':parseInt(Math.floor(list.progress*100)),
			        	'data-listid':list.listId   
			           }).show();
				nowPlaying.toggleClass('mastered',list.progress>=1);
				nowPlaying.removeClass('allwords');
				$header.drawProgress();	
			}
		});
		VCOM.on('login',function(){		
			
			function close() {
				nowPlaying.find('header').trigger('click');
			}
			
			nowPlaying.on('click','header',function(){
				nowPlaying.toggleClass('open');
				if (nowPlaying.hasClass('open')) {	
					VCOM.history.push(close);
					
					var listData = VCOM.get('pdata').lists;		
					var $listOfLists = $('<ul class="listoflists"></ul>');
					$listOfLists.append('<li role="button" class="allwords">All Words</li>');
					if (listData && listData.length) { 
						$listOfLists.append(listData.map(function(e){
							var li = $('<li role="button"/>').data(e);		
							$('<i class="progress">')
							.attr({'data-prg':parseInt(Math.round(e.progress*100)),
							       'list-id':e.listId}).appendTo(li);
							$('<span class="title"></span>').text(e.name).appendTo(li);							
							return (e.current) ? li.addClass('selected') : li;
						}));
					}
					$listOfLists.append('<li role="button" class="find">Find a list to learn...</li>');				   
					$listOfLists.drawProgress();

					nowPlaying.find('section').scrollTop(0).empty().append($listOfLists);				
				} else {
					VCOM.history.remove(close);
				}
			}).on('click','li',function(e){
				VCOM.history.remove(close);
				nowPlaying.removeClass('open');
				var $this = $(this);
				var data = $this.data();
				if (e.target.nodeName == 'I') {
					VCOM.showList(data.listId);
				} else if (data.listId || $this.hasClass('allwords')) {
					VCOM.startList(data.listId);
				} else if ($this.hasClass('find')) {
					VCOM.showList();
				}
			});
			
			$('body > .wrapper').on('vcom.switchmode challenge.questionComplete challenge.go',function(e){
				VCOM.history.remove(close);
				nowPlaying.removeClass('open');
				if (VCOM.mode()==='play') {
					var slide = VCOM.challenge.slide();		
					if (slide && !slide.hasClass('complete')) {
						nowPlaying.showStatus();
					} else {					
						nowPlaying.hideStatus();
					}
				} else {
					nowPlaying.hideStatus();
				}
			});
			
			
		});
	})();
	
	// set up dictionary/challenge word progress status bar
	VCOM.on('login',function(){
		(function() {
			var bar = null;
			$('body > .wrapper.loggedin')
				.on('vcom.switchmode dictionary.loaded vcom.learnword.start vcom.learnword.stop challenge.go challenge.save challenge.questionComplete',update)
				.on('dictionary.loading',function(e){
					$.doTimeout('refresh-word-status');
					if (bar != null) bar.addClass('hidden');
				});
				
			function hide() {
				if (bar != null) bar.hideStatus();
				bar = null;
			}
			function update() {
				var mode = VCOM.mode()
				if (mode=='dict') {
					var wordData = $('#dictionary .slide.current').data();	
					if (wordData && wordData.learnable && wordData.word) {
						$.doTimeout('refresh-word-status',100,function(){
							VCOM.getProgress(wordData.word,function(progressData) {	
								bar = updateWordStatus(bar,progressData);							
							});					
						});
						return;
					} 			
				} else if (mode=='play') {
					var slide = $('#challenge .challenge-slide.selected');
					var word = (slide && slide.hasClass('complete') && slide.hasClass('saved')) ? slide.attr('word') : null;
					if (word) {
						$.doTimeout('refresh-word-status',100,function(){
							VCOM.getProgress(word,function(progressData) {	
								bar = updateWordStatus(bar,progressData);							
							});					
						});
						return;
					} 
				} 				
				// otherwise, hide
				hide();
			}			
		})();
		
		function updateWordStatus(bar,progressData) {
			if (bar != null) {
				if (bar.data('word')===progressData.wrd) {
					if (bar.hasClass('wordtools') && progressData.pri != -1) {
						bar.find('i').attr('data-prg',parseInt(progressData.prg*100));
					} else {
						bar.hideStatus();
						bar = null;
					}					
				} else {
					bar.hideStatus();
					bar = null;
				}
			}
			if (bar == null && progressData != null && progressData.lrn) {
				if (progressData.pri == -1) {
					if (VCOM.mode() =='dict') bar = createLearnBar(progressData.wrd);
				} else {
					bar = createToolBar(progressData.wrd,progressData);
					bar.drawProgress();
				}
			}
			return bar ? bar.showStatus() : bar;			
		}
		
		function createLearnBar(word) {
			return VCOM.status.create("Start learning this word")
			       .addClass('learnword').on('click',function() { 
						$(this).hideStatus();
						VCOM.startLearning(word);
					}).data('word',word);
		}
		function createToolBar(word,data) {
			var audio = data.aud ? data.aud[0]:null;
			var progress=parseInt(data.prg*100);
			var bar = VCOM.status.create('<button title="view your learning progress" class="progress" >\
						  <i class="progress"></i>\
						  Your progress on: <span></span>\
						</button>\
						<div class="actions">\
						<button title="look up this word" class="lookup ss-search"><span class="label">Look Up</span></button>\
						<button title="hear the word" class="hear ss-highvolume"><span class="label">Listen</span></button>\
						</div>');
			bar.addClass('wordtools').data('word',word)
			   .toggleClass('mastered',progress==100)
			   .find('.progress span').text(word||'').end()
			   .on('click',function(){ 
					VCOM.showWordProgress(word);
				})
				.find('.lookup').on('click',function(){
					VCOM.displayWord(word);		
					return false;
				}).end()
				.find('.hear').on('click',function(){
					VCOM._playAudio(audio);		
					return false;
				});
			 bar.find('i').attr('data-prg',progress);
			 bar.drawProgress();
			 return bar;
		}
	});
		
	return status;
});