Module.define('vcom/usermenu',['jquery','vcom/base','format','template'],function($,VCOM,Format){
	var modalDown = {'transition':'.3s -webkit-transform','transform':'translate3d(0,100%,0)'};
	var modalUp   = {'transition':'.3s -webkit-transform','transform':'translate3d(0,0,0)'};
	
	
	VCOM.userMenu = {
		hide: hideMenu,
		show: showMenu
	};
	
	
	
	VCOM.showModal = showModal;
		
	function showMenu() {
		if (!$('body').hasClass('shifted')) {
			$('#side-menu').show().scrollTop(0).focus().template('usermenu.html',{pdata:VCOM.get('pdata'),auth:VCOM.get('auth')},function(){
				$(this).drawProgress();
			});
			$('body').addClass('shifted').append($('<div class="glasspane"></div>')
					.css({position:'absolute',top:0,left:0,bottom:0,right:0,zIndex:900})
                	.one('click',hideMenu));
			VCOM.history.push(hideMenu);
		}
	}
	
	function hideMenu(e) {
		if ($('body').hasClass('shifted')) {
			$(':focus').blur();
			$('body').one( 'webkitTransitionEnd', function() { 
				$('#side-menu').hide();
			} ).removeClass('shifted');
			$('.glasspane').remove();
			if (e && e.preventDefault) e.preventDefault();
			VCOM.history.remove(hideMenu);
		}
	}
	
	function showModal(content,options) {
		options = $.extend(options||{},{hidden:false});
		var modal = $('<div class="modal"><button class="done">DONE</button><section></section></div>')
		            .css('transform','translate3d(0,100%,0)') 
					.find('section').append(content).end();
		modal.hide = function() {
			modal.one('webkitTransitionEnd transitionEnd',function(){ 
				modal.remove();
			});
			modal.trigger('modal.hide');
			modal.css(modalDown);
			if ($('body > .modal').length==1) {
				$('body').removeClass('withmodal');
			}
			VCOM.history.remove(modal.hide);
		};
		modal.show = function() {
			$('body').addClass('withmodal');
			modal[0].clientWidth; // trigger layout
			modal.css(modalUp);
			hideMenu();
			VCOM.history.push(modal.hide);
		};
		modal.find('button.done').on('click',modal.hide);
		modal.appendTo('body');
		if (!options.hidden) {
			modal[0].clientWidth;
			modal.show();			
		}
		return modal;
	}
	VCOM.showModal=showModal;
	
	VCOM.on('login',function(){
		var auth = VCOM.get('auth');
		var pdata = VCOM.get('pdata');

		var levelId  = null;
		var pts = 0;
		var pointDisplay = $('.loginInfo')
		    .html('<div class="nickname"></div><div class="points"></div><div class="levelbadge"></div>')
		    .find('.nickname').text(auth.nickname).end().find('.points');
		$('header.page-header button.menu').on('click',showMenu);		
		
		$('#side-menu')
			.on('swipeleft',hideMenu)
			.on('click','.logout',function(){
				hideMenu();
				VCOM.logout();
			})
			.on('click','.feedback', function(){ VCOM.submitFeedback(); })
			.on('click','.rate', function(){ VCOM.rateApp(); })		
			.on('click','.actions .learningwords',function() {
				VCOM.showUserVocab('learning');
			})
			.on('click','.actions .masteredwords',function() {
				VCOM.showUserVocab('mastered');
			})
			.on('click','.actions .allwords',function() {
				VCOM.showUserVocab('all');
			})
			.on('click','li[data-list-id]',function() {
				VCOM.showList($(this).data('list-id'));			
			})
			.on('click','li.find-list',function() {
				VCOM.showList();			
			})
			.on('click','.actions li',function(){ 
				VCOM.userMenu.hide();			
			});
		
		$('.loginInfo .levelbadge').attr('class','levelbadge '+pdata.level.id).attr('title',pdata.level.name);
		animateScore(pdata.points, pts = pdata.points);
		
		$('body').on('challenge.update',function(evt) {
			if (evt.pdata) {
				pdata = evt.pdata;				
				if (pointDisplay) {
					animateScore(pts||pdata.points, pts = pdata.points);
					if (levelId != pdata.level.id) {
						$('.loginInfo .levelbadge').attr('class','levelbadge '+pdata.level.id).attr('title',pdata.level.name);
					}
				}
			}
		});
		
		
		function animateScore(from,to,step) {			
			if (!step) step = Math.ceil((to-from)/20);				
			var s = Math.min(from,to);
			if (s<to) setTimeout(function(){ animateScore(from+step,to,step)},40)			
			pointDisplay.html(Format.commaFormat(s));
		}
		
	});
});